#!/usr/bin/perl -w
use strict;
use Net::hostent;              # for OO version of gethostbyaddr
use IO::Socket;
my ($host, $port, $kidpid, $handle_out, $line);

unless (@ARGV == 2) { die "usage: $0 host port" }
($host_out, $port_out) = @ARGV;

    # create a tcp connection to the specified host and port
    $handle_out = IO::Socket::INET->new(Proto     => "tcp",
                                    PeerAddr  => $host_out,
                                    PeerPort  => $port_out)
           or die "can't connect to port $port on $host: $!";


	$port_in = 9000;                  # pick something not in use

	$handle_in = IO::Socket::INET->new( Proto     => 'tcp',
                                  LocalPort => $port_in,
                                  Listen    => SOMAXCONN,
                                  Reuse     => 1);

	die "can't setup server" unless $handle_in;
	print "[Server $0 accepting clients]\n";


    $handle->autoflush(1);              # so output gets there right away
    print STDERR "[Connected to $host:$port]\n";

    # split the program into two processes, identical twins
    die "can't fork: $!" unless defined($kidpid = fork());

    # the if{} block runs only in the parent process
    if ($kidpid) {
        # copy the socket to standard output
        while (defined ($line = <$handle_out>)) {
            print STDOUT $line;
        }
        kill("TERM", $kidpid);                  # send SIGTERM to child
    }
    # the else{} block runs only in the child process
    else {
        # copy standard input to the socket
        while (defined ($line = <STDIN>)) {
            print $handle_out $line;
        }
    }






#------------------



 while ($client = $server->accept()) {
   $client->autoflush(1);
   print $client "Welcome to $0; type help for command list.\n";
   $hostinfo = gethostbyaddr($client->peeraddr);
   printf "[Connect from %s]\n", $hostinfo->name || $client->peerhost;
   print $client "Command? ";
   while ( <$client>) {
     next unless /\S/;       # blank line
     if    (/quit|exit/i)    { last;                                     }
     elsif (/date|time/i)    { printf $client "%s\n", scalar localtime;  }
     elsif (/who/i )         { print  $client ho 2>&1;                }
     elsif (/cookie/i )      { print  $client /usr/games/fortune 2>&1; }
     elsif (/motd/i )        { print  $client at /etc/motd 2>&1;      }
     else {
       print $client "Commands: quit date who cookie motd\n";
     }
   } continue {
      print $client "Command? ";
   }
   close $client;
 }